Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	
	
	Private Declare Sub Sleep Lib "kernel32.dll" (ByVal tm As Integer)
	
	
	Private Sub ClearDevices()
		ListView_Dev.Items.Clear()
	End Sub
	
	Private Function GetDevType(ByVal devtype As Byte) As String
        Dim i As Byte
		Dim strtype As String
		Dim devarr(40) As Byte
		Dim namearr(40) As String
		devarr(0) = 1
		devarr(1) = 2
		devarr(2) = 3
		devarr(3) = 4
		devarr(4) = 5
		devarr(5) = 6
		devarr(6) = 7
		devarr(7) = 8
		devarr(8) = 17
		devarr(9) = 18
		devarr(10) = 19
		devarr(11) = 20
        devarr(12) = 21
        devarr(13) = 22
        devarr(14) = 23
        devarr(15) = 48
		
		namearr(0) = "ZNE-100"
		namearr(1) = "ZNE-100T"
		namearr(2) = "ZNE-10"
		namearr(3) = "ZNE-200T"
		namearr(4) = "NETCOM-10"
		namearr(5) = "ZNE-200"
		namearr(6) = "ZNE-10T"
		namearr(7) = "ZNE-100TI"
		namearr(8) = "CANET-E"
		namearr(9) = "CANET-100"
		namearr(10) = "CANET-200"
		namearr(11) = "CANET-100T"
		namearr(12) = "CANET-200T"
        namearr(13) = "CANET_ET"
        namearr(14) = "CANET_2ET"
        namearr(15) = "NETCOM-400"
		
		strtype = Str(devtype)
		For i = 0 To 11
            If devarr(i) = devtype Then
                strtype = strtype & "(" & namearr(i) & ")"
            End If
		Next 
		
		GetDevType = strtype
	End Function
	
	Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click
        ClearDevices()
        ZN_SearchAll()
        Dim times As Integer
        Dim szip(20) As Byte
        Dim szver(20) As Byte
        Dim szmac(30) As Byte
        'Dim devtype As Object
        Dim devtype As Byte
        Dim ipmode As Byte
        Dim tcpport As Integer
        Dim itmX As System.Windows.Forms.ListViewItem
        For times = 0 To 200
            While ZN_GetSearchDev(szip(0), szver(0), szmac(0), devtype, ipmode, tcpport) = 1
                itmX = ListView_Dev.Items.Add(System.Text.Encoding.ASCII.GetString(szip))
                If itmX.SubItems.Count > 1 Then
                    itmX.SubItems(1).Text = GetDevType(devtype)
                Else
                    itmX.SubItems.Insert(1, New System.Windows.Forms.ListViewItem.ListViewSubItem(Nothing, GetDevType(devtype)))
                End If
                If itmX.SubItems.Count > 2 Then
                    itmX.SubItems(2).Text = System.Text.Encoding.ASCII.GetString(szmac)
                Else
                    itmX.SubItems.Insert(2, New System.Windows.Forms.ListViewItem.ListViewSubItem(Nothing, System.Text.Encoding.ASCII.GetString(szmac)))
                End If
                If devtype >= 48 Then
                    If itmX.SubItems.Count > 3 Then
                        itmX.SubItems(3).Text = Str(tcpport)
                    Else
                        itmX.SubItems.Insert(3, New System.Windows.Forms.ListViewItem.ListViewSubItem(Nothing, Str(tcpport)))
                    End If
                End If
            End While
            Sleep((10))
        Next
    End Sub
	
	Private Function TryGetSelDev() As Integer
		If ListView_Dev.FocusedItem Is Nothing Then
			MsgBox("ѡһ豸")
			TryGetSelDev = -1
			Exit Function
		End If
		TryGetSelDev = ListView_Dev.FocusedItem.Index
	End Function
	
	Private Function GetInfo_CANNew(ByVal devtype As Byte, ByVal szip As String, ByVal szmac As String) As Integer
		Dim res As Integer
		res = ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype)
		Dim szval(100) As Byte
		
		If res <> 1 Then
			GetInfo_CANNew = 0
			Exit Function
		End If
		
		res = ZN_GetDevConfigUDP("NAME", szval(0))
		If res = 1 Then
            Text_Name.Text = System.Text.Encoding.ASCII.GetString(szval)
		End If
		
		res = ZN_GetDevConfigUDP("CAN1_WORK_PORT", szval(0))
		If res = 1 Then
            WORK_PORT.Text = System.Text.Encoding.ASCII.GetString(szval)
		End If
		
		
		res = ZN_GetDevConfigUDP("CAN1_DES_IP1", szval(0))
		If res = 1 Then
            DSP_IP_1.Text = System.Text.Encoding.ASCII.GetString(szval)
		End If
		
		res = ZN_GetDevConfigUDP("CAN1_DES_PORT1", szval(0))
		If res = 1 Then
            DSP_PORT_1.Text = System.Text.Encoding.ASCII.GetString(szval)
		End If
		
		
		res = ZN_GetDevConfigUDP("CAN1_BAUD", szval(0))
		If res = 1 Then
            CAN_1_BAUD.Text = System.Text.Encoding.ASCII.GetString(szval)
		End If
		
		res = ZN_GetDevConfigUDP("CAN1_LISTEN_MD", szval(0))
		If res = 1 Then
            CAN_1_WORK_MODE.Text = System.Text.Encoding.ASCII.GetString(szval)
		End If
		
		
		GetInfo_CANNew = res
	End Function
	
    Private Function GetInfo_CANOld(ByVal devtype As Byte, ByVal szip As String, ByVal szmac As String) As Integer
        Dim res As Integer
        res = ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype)
        Dim szval(100) As Byte
        If res <> 1 Then
            GetInfo_CANOld = 0
            Exit Function
        End If

        res = ZN_GetDevConfigUDP("NAME", szval(0))
        If res = 1 Then
            Text_Name.Text = System.Text.Encoding.ASCII.GetString(szval)
        End If


        res = ZN_GetDevConfigUDP("C1_PORT", szval(0))
        If res = 1 Then
            WORK_PORT.Text = System.Text.Encoding.ASCII.GetString(szval)
        End If

        res = ZN_GetDevConfigUDP("CANBUAD1", szval(0))
        If res = 1 Then
            CAN_1_BAUD.Text = System.Text.Encoding.ASCII.GetString(szval)
        End If

        res = ZN_GetDevConfigUDP("CANDESIP1", szval(0))
        If res = 1 Then
            DSP_IP_1.Text = System.Text.Encoding.ASCII.GetString(szval)
        End If


        res = ZN_GetDevConfigUDP("CANDESPORT1", szval(0))
        If res = 1 Then
            DSP_PORT_1.Text = System.Text.Encoding.ASCII.GetString(szval)
        End If




        res = ZN_GetDevConfigUDP("CANLISTENMD1", szval(0))
        If res = 1 Then
            CAN_1_WORK_MODE.Text = System.Text.Encoding.ASCII.GetString(szval)
        End If


        GetInfo_CANOld = res
    End Function
	
	Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click
		Dim selind As Object
        selind = TryGetSelDev()
        If selind = -1 Then
            Exit Sub
        End If
		Dim szip, szmac As String
		Dim str1 As String
		Dim devtype As Byte
		szip = ListView_Dev.Items.Item(selind).Text
		str1 = ListView_Dev.Items.Item(selind).SubItems(1).Text
		devtype = Val(str1)
		szmac = ListView_Dev.Items.Item(selind).SubItems(2).Text

		
        Dim getType_Renamed As Integer
		Dim res As Integer
		
		getType_Renamed = 0
		If devtype = 17 Then getType_Renamed = 1
		If devtype = 18 Then getType_Renamed = 1
		If devtype = 19 Then getType_Renamed = 1
		If devtype = 20 Then getType_Renamed = 2
        If devtype = 21 Then getType_Renamed = 2
        If devtype = 22 Then getType_Renamed = 2
        If devtype = 23 Then getType_Renamed = 2
		
		If getType_Renamed = 1 Then
            res = GetInfo_CANOld(devtype, szip, szmac)
		ElseIf getType_Renamed = 2 Then 
			res = GetInfo_CANNew(devtype, szip, szmac)
		Else
			MsgBox("ִ֧")
		End If
		
		If res <> 1 Then
			MsgBox("ȡϢʧ")
		Else
			MsgBox("ȡϢɹ")
		End If
		
	End Sub
	
	Private Function Modify_CANNew(ByVal devtype As Byte, ByVal szip As String, ByVal szmac As String) As Integer
		CDlgPwd.ShowDialog()
		
		If CDlgPwd.isOK() = 0 Then
			Modify_CANNew = 0
			Exit Function
		End If
		Dim szpwd As String
		szpwd = CDlgPwd.Text1.Text
		
		Dim res As Integer
		res = 1
		
		ZN_ResetModifyConfigUDP()
		
		
		'//޸
		res = ZN_SetModifyConfigUDP("NAME", Text_Name.Text)
		res = ZN_SetModifyConfigUDP("CAN1_WORK_PORT", WORK_PORT.Text)
		res = ZN_SetModifyConfigUDP("CAN1_DES_IP1", DSP_IP_1.Text)
		res = ZN_SetModifyConfigUDP("CAN1_DES_PORT1", DSP_PORT_1.Text)
		res = ZN_SetModifyConfigUDP("CAN1_BAUD", CAN_1_BAUD.Text)
		res = ZN_SetModifyConfigUDP("CAN1_LISTEN_MD", CAN_1_WORK_MODE.Text)
		
		If res <> 1 Then
			Modify_CANNew = 0
			Exit Function
		End If
		
		res = ZN_ModifyDevUDPbyMACAndIP(szmac, szip, szpwd, devtype)
		If res <> 1 Then
			Modify_CANNew = 0
			Exit Function
		End If
		
		Sleep(4000)
		'//УǷĳɹ
		res = ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype)
		If res <> 1 Then
			Modify_CANNew = 0
			Exit Function
		End If
		
		Dim szvalnew(100) As Byte
		
        If ZN_GetDevConfigUDP("NAME", szvalnew(0)) = 1 Then
            If System.String.Compare(Text_Name.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANNew = 0
                Exit Function
            End If
        End If

        If ZN_GetDevConfigUDP("CAN1_WORK_PORT", szvalnew(0)) = 1 Then
            If System.String.Compare(WORK_PORT.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANNew = 0
                Exit Function
            End If
        End If

        If ZN_GetDevConfigUDP("CAN1_DES_IP1", szvalnew(0)) = 1 Then
            If System.String.Compare(DSP_IP_1.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANNew = 0
                Exit Function
            End If
        End If

        If ZN_GetDevConfigUDP("CAN1_DES_PORT1", szvalnew(0)) = 1 Then
            If System.String.Compare(DSP_PORT_1.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANNew = 0
                Exit Function
            End If
        End If

        If ZN_GetDevConfigUDP("CAN1_BAUD", szvalnew(0)) = 1 Then
            If System.String.Compare(CAN_1_BAUD.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANNew = 0
                Exit Function
            End If
        End If

        If ZN_GetDevConfigUDP("CAN1_LISTEN_MD", szvalnew(0)) = 1 Then
            If System.String.Compare(CAN_1_WORK_MODE.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANNew = 0
                Exit Function
            End If
        End If

        Modify_CANNew = res
	End Function
	
    Private Function Modify_CANOld(ByVal devtype As Byte, ByVal szip As String, ByVal szmac As String) As Integer
        Dim res As Object
        Dim Modify_MultiCOM As Object
        CDlgPwd.ShowDialog()

        If CDlgPwd.isOK() = 0 Then
            Modify_MultiCOM = 0
            Exit Function
        End If
        Dim szpwd As String
        szpwd = CDlgPwd.Text1.Text
        ZN_ResetModifyConfigUDP()

        res = ZN_SetModifyConfigUDP("NAME", Text_Name.Text)
        res = ZN_SetModifyConfigUDP("C1_PORT", WORK_PORT.Text)
        res = ZN_SetModifyConfigUDP("CANDESIP1", DSP_IP_1.Text)
        res = ZN_SetModifyConfigUDP("CANDESPORT1", DSP_PORT_1.Text)
        res = ZN_SetModifyConfigUDP("CANBAUD1", CAN_1_BAUD.Text)
        res = ZN_SetModifyConfigUDP("CANLISTENMD1", CAN_1_WORK_MODE.Text)

        res = ZN_ModifyDevUDPbyMACAndIP(szmac, szip, szpwd, devtype)
        If res <> 1 Then
            Modify_CANOld = 0
            Exit Function
        End If

        Sleep((500))

        res = ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype)
        If res <> 1 Then
            Modify_CANOld = 0
            Exit Function
        End If

        Dim szvalnew(100) As Byte

        If ZN_GetDevConfigUDP("NAME", szvalnew(0)) = 1 Then
            If System.String.Compare(Text_Name.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANOld = 0
                Exit Function
            End If
        End If

        If ZN_GetDevConfigUDP("C1_PORT", szvalnew(0)) = 1 Then
            If System.String.Compare(WORK_PORT.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                    Modify_CANOld = 0
                Exit Function
            End If
        End If

        If ZN_GetDevConfigUDP("CANDESIP1", szvalnew(0)) = 1 Then
            If System.String.Compare(DSP_IP_1.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANOld = 0
                Exit Function
            End If
        End If

        If ZN_GetDevConfigUDP("CANDESPORT1", szvalnew(0)) = 1 Then
            If System.String.Compare(DSP_PORT_1.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANOld = 0
                Exit Function
            End If
        End If

        If ZN_GetDevConfigUDP("CANBAUD1", szvalnew(0)) = 1 Then
            If System.String.Compare(CAN_1_BAUD.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANOld = 0
                Exit Function
            End If
        End If

        If ZN_GetDevConfigUDP("CANLISTENMD1", szvalnew(0)) = 1 Then
            If System.String.Compare(CAN_1_WORK_MODE.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.Ordinal) = False Then
                Modify_CANOld = 0
                Exit Function
            End If
        End If

        Modify_CANOld = 1
    End Function
	
	Private Sub Command3_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command3.Click
		Dim selind As Object
        selind = TryGetSelDev()
        If selind = -1 Then
            Exit Sub
        End If
		Dim szip As String
		Dim szmac As String
		Dim str1 As String
		Dim devtype As Byte
        szip = ListView_Dev.Items.Item(selind).Text
        str1 = ListView_Dev.Items.Item(selind).SubItems(1).Text
        szmac = ListView_Dev.Items.Item(selind).SubItems(2).Text
		devtype = Val(str1)

		
        Dim getType_Renamed As Integer
		Dim res As Integer
		
		getType_Renamed = 0
		If devtype = 17 Then getType_Renamed = 1
		If devtype = 18 Then getType_Renamed = 1
		If devtype = 19 Then getType_Renamed = 1
		If devtype = 20 Then getType_Renamed = 2
        If devtype = 21 Then getType_Renamed = 2
        If devtype = 22 Then getType_Renamed = 2
        If devtype = 23 Then getType_Renamed = 2
		
		If getType_Renamed = 1 Then
            res = Modify_CANOld(devtype, szip, szmac)
		ElseIf getType_Renamed = 2 Then 
			res = Modify_CANNew(devtype, szip, szmac)
		Else
			MsgBox("ִ֧")
		End If
		
		If res <> 1 Then
			MsgBox("Ϣʧ")
		Else
			MsgBox("Ϣɹ")
		End If
	End Sub
End Class