// testznetadvDlg.cpp : implementation file
//

#include "stdafx.h"
#include "testznetadv.h"
#include "testznetadvDlg.h"
#include "znetadv.h"
#include "DlgPwd1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestznetadvDlg dialog
// static CString g_strname[]={"NAME","C1_OP","C1_PORT","C1_BAUD","C1_DATAB",
// 	"C1_STOPB","C1_PARITY"};
// static UINT g_idarr[]={IDC_EDIT_NAME,IDC_EDIT_WORKTYPE,IDC_EDIT_PORT,
// 	IDC_EDIT_BAUD,IDC_EDIT_DATAB,IDC_EDIT_STOPB,IDC_EDIT_PARITY};

CTestznetadvDlg::CTestznetadvDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestznetadvDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestznetadvDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestznetadvDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestznetadvDlg)
	DDX_Control(pDX, IDC_LIST_DEV, m_ctlList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestznetadvDlg, CDialog)
	//{{AFX_MSG_MAP(CTestznetadvDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SEARCH, OnButtonSearch)
	ON_BN_CLICKED(IDC_BUTTON_GETINFO, OnButtonGetinfo)
	ON_BN_CLICKED(IDC_BUTTON_MODIFY, OnButtonModify)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestznetadvDlg message handlers

BOOL CTestznetadvDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ctlList.InsertColumn(0,"IP",LVCFMT_LEFT,120,0);
	m_ctlList.InsertColumn(1,"ͺ",LVCFMT_LEFT,80,1);
	m_ctlList.InsertColumn(2,"MAC",LVCFMT_LEFT,120,2);
	m_ctlList.InsertColumn(3,"TCP˿",LVCFMT_LEFT,80,3);
	m_ctlList.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestznetadvDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestznetadvDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestznetadvDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestznetadvDlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

void CTestznetadvDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CTestznetadvDlg::OnButtonSearch() 
{
	ClearDevices();
	ZN_SearchAll();
	int times=200;
	char szip[20],szver[20],szmac[30];
	BYTE devtype,ipmode;
	int tcpport;
	while(times-->0)
	{
		while(ZN_GetSearchDev(szip,szver,szmac,&devtype,&ipmode,&tcpport)==1)
		{
			int ind=m_ctlList.InsertItem(m_ctlList.GetItemCount(),szip);
			m_ctlList.SetItemText(ind,1,GetDevType(devtype));
			m_ctlList.SetItemText(ind,2,szmac);
			if(devtype>=TYPE_NETCOM400)
			{
				CString str1;
				str1.Format("%d",tcpport);
				m_ctlList.SetItemText(ind,3,str1);
			}
		}
		Sleep(10);
	}
}

void CTestznetadvDlg::ClearDevices()
{
	m_ctlList.DeleteAllItems();
}

CString CTestznetadvDlg::GetDevType(BYTE devtype)
{
	static BYTE devarr[]={TYPE_ZNE100,TYPE_ZNE100T,TYPE_ZNE10,TYPE_ZNE200T,
		TYPE_ZNETCOM10S,TYPE_ZNE200,TYPE_ZNE10T,TYPE_ZNE100TI,TYPE_CANETE,
		TYPE_CANET100,TYPE_CANET200,TYPE_CANET100T, TYPE_CANET200T,
		TYPE_CANET_ET,TYPE_CANET_2ET,TYPE_NETCOM400};
	static CString namearr[]={"ZNE-100","ZNE-100T","ZNE-10","ZNE-200T",
		"NETCOM-10","ZNE-200","ZNE-10T","ZNE-100TI","CANET-E",
		"CANET-100","CANET-200","CANET-100T","CANET-200T",
		"CANET_ET","CANET_2ET","NETCOM-400"};

	int sz=sizeof(devarr);
	CString str1;
	for(int i=0;i<sz;i++)
	{
		if(devarr[i]==devtype)
		{
			str1.Format("%d(%s)",devtype,namearr[i]);
			return str1;
		}
	}
	str1.Format("%d",devtype);
	return str1;
}

void CTestznetadvDlg::OnButtonGetinfo() 
{
	// TODO: Add your control notification handler code here
	int selind=TryGetSelDev();
	if(selind==-1)
	{
		return;
	}

	char szip[20],szmac[30];
	CString str1;
	BYTE devtype;
	int tcpport;
	m_ctlList.GetItemText(selind,0,szip,20);
	str1=m_ctlList.GetItemText(selind,1);
	devtype=atoi(str1);

	m_ctlList.GetItemText(selind,2,szmac,30);
	str1=m_ctlList.GetItemText(selind,3);
	if(str1!="")
		tcpport=atoi(str1);
	int res;

	if(devtype == TYPE_CANET100 || devtype == TYPE_CANET200 || devtype == TYPE_CANETE)
	{
		res=GetInfo_CanOld(szmac,devtype, szip);
	}	
	else if (devtype == TYPE_CANET200T || devtype == TYPE_CANET100T || devtype == TYPE_CANWIFI_2)
	{
		res=GetInfo_CanNew(szmac, devtype,szip);
	}
	else
	{
		MessageBox("ֵ֧豸");
		return ;
	}

	if(res!=1)
		MessageBox("ȡϢʧ");
	else
		MessageBox("ȡϢɹ");

}

int CTestznetadvDlg::TryGetSelDev()
{
	POSITION pos=m_ctlList.GetFirstSelectedItemPosition();
	if(pos)
	{
		int ind=m_ctlList.GetNextSelectedItem(pos);
		return ind;
	}
	MessageBox("ѡһ豸");
	return -1;
}

void CTestznetadvDlg::OnButtonModify() 
{
	// TODO: Add your control notification handler code here
	int selind=TryGetSelDev();
	if(selind==-1)
	{
		return;
	}
	char szip[20],szmac[30];
	CString str1;
	BYTE devtype;
	int tcpport;
	m_ctlList.GetItemText(selind,0,szip,20);
	str1=m_ctlList.GetItemText(selind,1);
	devtype=atoi(str1);
	m_ctlList.GetItemText(selind,2,szmac,30);
	str1=m_ctlList.GetItemText(selind,3);
	if(str1!="")
		tcpport=atoi(str1);
	int res;

	
	if(devtype == TYPE_CANET100 || devtype == TYPE_CANET200 || devtype == TYPE_CANETE)
	{
		res=Modify_CanOld(szmac,devtype, szip);
	}
	else if (devtype == TYPE_CANET200T || devtype == TYPE_CANET100T || devtype == TYPE_CANET_ET || devtype == TYPE_CANET_2ET)
	{
		res=Modify_CanNew(szmac, devtype,szip);
	}
	else
	{
		MessageBox("ֵ֧豸");
		return ;
	}

	if(res!=1)
		MessageBox("Ϣʧ");
	else
		MessageBox("Ϣɹ");
	
}

int CTestznetadvDlg::Modify_CanOld(char* szmac, BYTE devtype, char *szip)
{
	ZN_ResetModifyConfigUDP();

	char szval[32] ={0};
	
	CDlgPwd dlg;
	if(dlg.DoModal()!=IDOK)
		return 0;
	char szpwd[20];
	strcpy(szpwd,dlg.GetPwd());

	//޸
	GetDlgItem(IDC_EDIT_WORK_PORT)->GetWindowText(szval, 32);
	if (ZN_SetModifyConfigUDP("C1_PORT",szval) != 1)
		return 0;
	
	GetDlgItem(IDC_EDIT_DESIP_1)->GetWindowText(szval, 32);
	if (ZN_SetModifyConfigUDP("CANDESIP1",szval) != 1)
		return 0;

	GetDlgItem(IDC_EDIT_DESPORT_1)->GetWindowText(szval, 32);
	if (ZN_SetModifyConfigUDP("CANDESPORT1",szval) != 1)
		return 0;
	
	GetDlgItem(IDC_EDIT_CAN_BAUD)->GetWindowText(szval, 32);
	if (ZN_SetModifyConfigUDP("CANBAUD1",szval) != 1)
		return 0;
	
	GetDlgItem(IDC_EDIT_WORK_MODE)->GetWindowText(szval, 32);
	if (ZN_SetModifyConfigUDP("CANLISTENMD1",szval) != 1)
		return 0;

	if (ZN_ModifyDevUDPbyMACAndIP(szmac, szip, szpwd, devtype) != 1)
		return 0;

	//УǷĳɹ
	if (ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype) != 1)
		return 0;

	CString strtmp;

	//˿
	if (ZN_GetDevConfigUDP("C1_PORT", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_WORK_PORT)->GetWindowText(strtmp);
	if (strtmp.Compare(szval) != 0)
		return 0;
	//ip
	if (ZN_GetDevConfigUDP("CANDESIP1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_DESIP_1)->GetWindowText(strtmp);
	if (strtmp.Compare(szval) != 0)
		return 0;
	//Ŀ˿
	if (ZN_GetDevConfigUDP("CANDESPORT1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_DESPORT_1)->GetWindowText(strtmp);
	if (strtmp.Compare(szval) != 0)
		return 0;
	//
	if (ZN_GetDevConfigUDP("CANBAUD1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_CAN_BAUD)->GetWindowText(strtmp);
	if (strtmp.Compare(szval) != 0)
		return 0;
	//ģʽ
	if (ZN_GetDevConfigUDP("CANLISTENMD1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_WORK_MODE)->GetWindowText(strtmp);
	if (strtmp.Compare(szval) != 0)
		return 0;

	return 1;
	
}

int CTestznetadvDlg::Modify_CanNew(char* szmac, BYTE devtype, char *szip)
{
	ZN_ResetModifyConfigUDP();
	
	char szval[32] ={0};
	
	CDlgPwd dlg;
	if(dlg.DoModal()!=IDOK)
		return 0;
	char szpwd[20];
	strcpy(szpwd,dlg.GetPwd());
	
	//޸
	GetDlgItem(IDC_EDIT_WORK_PORT)->GetWindowText(szval, 32);
	if (ZN_SetModifyConfigUDP("CAN1_WORK_PORT",szval) != 1)
		return 0;
	
	GetDlgItem(IDC_EDIT_DESIP_1)->GetWindowText(szval, 32);
	if (ZN_SetModifyConfigUDP("CAN1_DES_IP1",szval) != 1)
		return 0;
	
	GetDlgItem(IDC_EDIT_DESPORT_1)->GetWindowText(szval, 32);
	if (ZN_SetModifyConfigUDP("CAN1_DES_PORT1",szval) != 1)
		return 0;
	
	GetDlgItem(IDC_EDIT_CAN_BAUD)->GetWindowText(szval, 32);
	if (ZN_SetModifyConfigUDP("CAN1_BAUD",szval) != 1)
		return 0;
	
	GetDlgItem(IDC_EDIT_WORK_MODE)->GetWindowText(szval, 32);
	if (ZN_SetModifyConfigUDP("CAN1_LISTEN_MD",szval) != 1)
		return 0;
	
	if (ZN_ModifyDevUDPbyMACAndIP(szmac, szip, szpwd, devtype) != 1)
		return 0;
	
	Sleep(4000);
	//УǷĳɹ
	if (ZN_GetDevInfoUDPbyMACAndIP(szmac,  szip, devtype) != 1)
		return 0;
	
	CString strtmp;
	
	//˿
	if (ZN_GetDevConfigUDP("CAN1_WORK_PORT", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_WORK_PORT)->GetWindowText(strtmp);
	if (strtmp.Compare(szval) != 0)
		return 0;
	//ip
	if (ZN_GetDevConfigUDP("CAN1_DES_IP1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_DESIP_1)->GetWindowText(strtmp);
	if (strtmp.Compare(szval) != 0)
		return 0;
	//Ŀ˿
	if (ZN_GetDevConfigUDP("CAN1_DES_PORT1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_DESPORT_1)->GetWindowText(strtmp);
	if (strtmp.Compare(szval) != 0)
		return 0;
	//
	if (ZN_GetDevConfigUDP("CAN1_BAUD", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_CAN_BAUD)->GetWindowText(strtmp);
	if (strtmp.Compare(szval) != 0)
		return 0;
	//ģʽ
	if (ZN_GetDevConfigUDP("CAN1_LISTEN_MD", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_WORK_MODE)->GetWindowText(strtmp);
	if (strtmp.Compare(szval) != 0)
		return 0;
	
	return 1;
}


int CTestznetadvDlg::GetInfo_CanOld(char* szmac, BYTE devtype, char *szip)
{
	if (ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype) != 1)
		return 0;

	char szval[32] = {0};
	if (ZN_GetDevConfigUDP("C1_PORT", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_WORK_PORT)->SetWindowText(szval);

	if (ZN_GetDevConfigUDP("CANDESIP1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_DESIP_1)->SetWindowText(szval);

	if (ZN_GetDevConfigUDP("CANDESPORT1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_DESPORT_1)->SetWindowText(szval);

	if (ZN_GetDevConfigUDP("CANBAUD1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_CAN_BAUD)->SetWindowText(szval);

	if (ZN_GetDevConfigUDP("CANLISTENMD1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_WORK_MODE)->SetWindowText(szval);

	
	if (ZN_GetDevConfigUDP("NAME", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_NAME)->SetWindowText(szval);
	
	

	return 1;
}

int CTestznetadvDlg::GetInfo_CanNew( char* szmac,BYTE devtype,char *szip)
{
	
	if (ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype) != 1)
		return 0;
	
	char szval[32] = {0};
	if (ZN_GetDevConfigUDP("CAN1_WORK_PORT", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_WORK_PORT)->SetWindowText(szval);
	
	if (ZN_GetDevConfigUDP("CAN1_DES_IP1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_DESIP_1)->SetWindowText(szval);
	
	if (ZN_GetDevConfigUDP("CAN1_DES_PORT1", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_DESPORT_1)->SetWindowText(szval);
	
	if (ZN_GetDevConfigUDP("CAN1_BAUD", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_CAN_BAUD)->SetWindowText(szval);
	
	if (ZN_GetDevConfigUDP("CAN1_LISTEN_MD", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_WORK_MODE)->SetWindowText(szval);
	
	if (ZN_GetDevConfigUDP("NAME", szval) != 1)
		return 0;
	GetDlgItem(IDC_EDIT_NAME)->SetWindowText(szval);

	return 1;

}
