unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,ZNetAdv,Unit2;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListView_Dev: TListView;
    Label1: TLabel;
    Edit_Name: TEdit;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Edit_Worktype: TEdit;
    Label3: TLabel;
    Edit_Workport: TEdit;
    Label4: TLabel;
    Edit_Baud: TEdit;
    Label5: TLabel;
    Edit_DataB: TEdit;
    Label6: TLabel;
    Edit_StopB: TEdit;
    Label7: TLabel;
    Edit_Parity: TEdit;
    Label8: TLabel;
    GroupBox2: TGroupBox;
    RadioUDP: TRadioButton;
    RadioTCP: TRadioButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
  published
    function GetDevType(devtype: BYTE): AnsiString;
    procedure ClearDevices;
    function GetInfo_TCP(devtype: BYTE; szip: AnsiString;
      tcpport: integer): integer;
    function TryGetSelDev: integer;
    function GetInfo_UDP(szmac: AnsiString; devtype: BYTE; szip: AnsiString): integer;
    function Modify_TCP(devtype: BYTE; szip: AnsiString;
      tcpport: integer): integer;
    function Modify_UDP(szmac: AnsiString; devtype: BYTE; szip: AnsiString): integer;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
times:integer;
szip : array[0..20] of CHAR;
szver : array[0..20] of CHAR;
szmac: array[0..30] of CHAR;
devtype: BYTE;
ipmode: BYTE;
tcpport: integer;
item: TListItem;
begin
	ClearDevices();
	ZN_SearchAll();
  times:=200;
	while(times>0) do
  begin
		while(ZN_GetSearchDev(@szip[0],@szver[0],@szmac[0],@devtype,@ipmode,@tcpport)=1) do
		begin
      item:=ListView_Dev.Items.Add();
      item.Data:=Pointer(devtype);
      item.Caption:=szip;
      item.SubItems.Add(GetDevType(devtype));
      item.SubItems.Add(szmac);
			if(devtype>=32) then
          item.SubItems.Add(IntToStr(tcpport))
      else
          item.SubItems.Add('');
		end;
		Sleep(10);
    times:=times-1;
	end;

end;

procedure TForm1.ClearDevices;
begin
    ListView_Dev.Items.Clear();
end;

function TForm1.GetDevType(devtype: BYTE): AnsiString;
var
strtype:AnsiString;
devarr: array[0..20] of BYTE;
namearr: array[0..20] of AnsiString;
i: integer;
begin
    devarr[0] := 1;
    devarr[1] := 2;
    devarr[2] := 3;
    devarr[3] := 4;
    devarr[4] := 5;
    devarr[5] := 6;
    devarr[6] := 7;
    devarr[7] := 8;
    devarr[8] := 11;
    devarr[9] := 12;
    devarr[10] := 13;
    devarr[11] := 48;

    namearr[0] := 'ZNE-100';
    namearr[1] := 'ZNE-100T';
    namearr[2] := 'ZNE-10';
    namearr[3] := 'ZNE-200T';
    namearr[4] := 'NETCOM-10';
    namearr[5] := 'ZNE-200';
    namearr[6] := 'ZNE-10T';
    namearr[7] := 'ZNE-100TI';
    namearr[8] := 'CANET-E';
    namearr[9] := 'CANET-100';
    namearr[10] := 'CANET-200';
    namearr[11] := 'NETCOM-400';


    strtype := IntToStr(devtype);
    For i:= 0 To 11 do
    begin
        If(devarr[i]=devtype) Then
            strtype := strtype + '(' + namearr[i] + ')';
    end;
    GetDevType := strtype;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
selind:integer;
szip,szmac,str1: AnsiString;
devtype: BYTE;
tcpport,res: integer;
begin
    selind := TryGetSelDev();
    If(selind = -1) Then
        Exit;
    szip:=ListView_Dev.Items.Item[selind].Caption;
    str1:=ListView_Dev.Items.Item[selind].SubItems[0];
    devtype:=BYTE(ListView_Dev.Items.Item[selind].Data);
//    devtype:=StrToInt(str1);
    szmac:=ListView_Dev.Items.Item[selind].SubItems[1];
    str1:=ListView_Dev.Items.Item[selind].SubItems[2];
    If(str1<>'') Then
        tcpport := StrToInt(str1);

    If(RadioTCP.Checked) Then
        res := GetInfo_TCP(devtype, szip, tcpport)
    else
        res := GetInfo_UDP(szmac, devtype, szip);
    If (res <> 1) Then
        ShowMessage ('ȡϢʧ')
    Else
        ShowMessage ('ȡϢɹ');
end;

function TForm1.GetInfo_TCP(devtype: BYTE; szip: AnsiString;
  tcpport: integer): integer;
var
szpwd:AnsiString;
res:integer;
szval: array [0..99] of CHAR;
label ext;
begin
    Form2.ShowModal();
    If(Form2.isOK() = 0) Then
    begin
        GetInfo_TCP := 0;
        Exit;
    end;
    szpwd := Form2.Edit1.Text;
    If(ZN_LoginTCP(devtype, PChar(szip), tcpport, PChar(szpwd)) <> 1) Then
    begin
        GetInfo_TCP := 0;
        Exit;
    end;
    res := 1;
    res := ZN_GetDevConfigTCP('NAME', @szval[0]);
    If (res <> 1) Then
        GoTo ext;
    Edit_Name.Text := szval;

    res := ZN_GetDevConfigTCP('C1_OP', @szval[0]);
    If (res <> 1) Then
        GoTo ext;
    Edit_Worktype.Text := szval;

    res := ZN_GetDevConfigTCP('C1_PORT', @szval[0]);
    If (res <> 1) Then
        GoTo ext;
    Edit_Workport.Text :=szval;

    res := ZN_GetDevConfigTCP('C1_BAUD', @szval[0]);
    If (res <> 1) Then
        GoTo ext;
    Edit_Baud.Text :=szval;

    res := ZN_GetDevConfigTCP('C1_DATAB', @szval[0]);
    If (res <> 1) Then
        GoTo ext;
    Edit_DataB.Text :=szval;

    res := ZN_GetDevConfigTCP('C1_STOPB', @szval[0]);
    If (res <> 1) Then
        GoTo ext;
    Edit_StopB.Text :=szval;

    res:= ZN_GetDevConfigTCP('C1_PARITY', @szval[0]);
    If (res <> 1) Then
        GoTo ext;
    Edit_Parity.Text :=szval;

ext:
    ZN_ExitTCP;
    GetInfo_TCP := res;
end;

function TForm1.TryGetSelDev: integer;
begin
    If(ListView_Dev.SelCount=0) Then
    begin
        ShowMessage ('ѡһ豸');
        TryGetSelDev := -1;
        Exit;
    end;
    TryGetSelDev := ListView_Dev.Selected.Index;
end;

function TForm1.GetInfo_UDP(szmac: AnsiString; devtype: BYTE;
  szip: AnsiString): integer;
var
res:integer;
szval:array[0..100] of CHAR;
begin
    res := ZN_GetDevInfoUDPbyMACAndIP(PChar(szmac), PChar(szip),devtype);
    If (res <> 1) Then
    begin
        GetInfo_UDP := 0;
        Exit;
    end;

    res := ZN_GetDevConfigUDP('NAME', @szval[0]);
    If (res = 1) Then
        Edit_Name.Text :=szval;

    res := ZN_GetDevConfigUDP('C1_OP', @szval[0]);
    If res = 1 Then
    Edit_Worktype.Text := szval;

    res := ZN_GetDevConfigUDP('C1_PORT', @szval[0]);
    If res = 1 Then
        Edit_Workport.Text := szval;

    res := ZN_GetDevConfigUDP('C1_BAUD', @szval[0]);
    If res = 1 Then
        Edit_Baud.Text := szval;

    res := ZN_GetDevConfigUDP('C1_DATAB', @szval[0]);
    If res = 1 Then
        Edit_DataB.Text := szval;

    res := ZN_GetDevConfigUDP('C1_STOPB', @szval[0]);
    If res = 1 Then
        Edit_StopB.Text := szval;

    res := ZN_GetDevConfigUDP('C1_PARITY', @szval[0]);
    If res = 1 Then
        Edit_Parity.Text := szval;

    GetInfo_UDP := res;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
selind:integer;
szip,str1,szmac:AnsiString;
devtype:BYTE;
tcpport:integer;
res:integer;
begin
    selind := TryGetSelDev();
    If(selind = -1) Then
        Exit;
    szip:=ListView_Dev.Items.Item[selind].Caption;
    szmac:=ListView_Dev.Items.Item[selind].SubItems[1];
    str1:=ListView_Dev.Items.Item[selind].SubItems[0];
    devtype:=BYTE(ListView_Dev.Items.Item[selind].Data);
    str1:=ListView_Dev.Items.Item[selind].SubItems[2];
    If(str1<>'') Then
        tcpport := StrToInt(str1);

    If(radioTCP.Checked) Then
        res := Modify_TCP(devtype, szip, tcpport)
    Else
        res := Modify_UDP(szmac, devtype, szip);
    If (res <> 1) Then
        ShowMessage ('Ϣʧ')
    Else
        ShowMessage ('Ϣɹ');
end;

function TForm1.Modify_TCP(devtype: BYTE; szip: AnsiString;
  tcpport: integer): integer;
var
res:integer;
szpwd:AnsiString;
label ext;
begin
    Form2.ShowModal();
    If(Form2.isOK() = 0) Then
    begin
        Modify_TCP := 0;
        Exit;
    end;
    szpwd := Form2.Edit1.Text;

    If(ZN_LoginTCP(devtype, PChar(szip), tcpport, PChar(szpwd)) <> 1) Then
    begin
        Modify_TCP := 0;
        Exit;
    end;
    res := 1;

    res := ZN_ModifyDevConfigTCP('NAME',PChar(Edit_Name.Text));
    If (res <> 1) Then
        GoTo ext;

    res := ZN_ModifyDevConfigTCP('C1_OP', PChar(Edit_Worktype.Text));
    If (res <> 1) Then
        GoTo ext;

    res := ZN_ModifyDevConfigTCP('C1_PORT', PChar(Edit_Workport.Text));
    If (res <> 1) Then
        GoTo ext;

    res := ZN_ModifyDevConfigTCP('C1_BAUD', PChar(Edit_Baud.Text));
    If (res <> 1) Then
        GoTo ext;

    res := ZN_ModifyDevConfigTCP('C1_DATAB', PChar(Edit_DataB.Text));
    If (res <> 1) Then
        GoTo ext;

    res := ZN_ModifyDevConfigTCP('C1_STOPB', PChar(Edit_StopB.Text));
    If (res <> 1) Then
        GoTo ext;

    res := ZN_ModifyDevConfigTCP('C1_PARITY', PChar(Edit_Parity.Text));
    If (res <> 1) Then
        GoTo ext;

ext:
    ZN_ResetDevTCP;
    ZN_ExitTCP;
    Modify_TCP := res;

end;

function TForm1.Modify_UDP(szmac: AnsiString; devtype: BYTE; szip: AnsiString): integer;
var
res:integer;
szpwd:AnsiString;
szvalnew:array[0..100] of CHAR;
begin
    Form2.ShowModal();
    If(Form2.isOK() = 0) Then
    begin
        Modify_UDP := 0;
        Exit;
    end;
    szpwd := Form2.Edit1.Text;

    ZN_ResetModifyConfigUDP;
    
    res := ZN_SetModifyConfigUDP('NAME', PChar(Edit_Name.Text));
    res := ZN_SetModifyConfigUDP('C1_OP', PChar(Edit_Worktype.Text));
    res := ZN_SetModifyConfigUDP('C1_PORT', PChar(Edit_Workport.Text));
    res := ZN_SetModifyConfigUDP('C1_BAUD', PChar(Edit_Baud.Text));
    res := ZN_SetModifyConfigUDP('C1_DATAB', PChar(Edit_DataB.Text));
    res := ZN_SetModifyConfigUDP('C1_STOPB', PChar(Edit_StopB.Text));
    res := ZN_SetModifyConfigUDP('C1_PARITY', PChar(Edit_Parity.Text));

    res := ZN_ModifyDevUDPbyMACAndIP(PChar(szmac), PChar(szip), PChar(szpwd), devtype);
    If (res <> 1) Then
    begin
        Modify_UDP := 0;
        Exit;
    end;
    Sleep (500);

    res := ZN_GetDevInfoUDPbyMACAndIP(PChar(szmac), PChar(szip), devtype);
    If (res <> 1) Then
    begin
        Modify_UDP := 0;
        Exit;
    end;
    
    
    If (ZN_GetDevConfigUDP('NAME', @szvalnew[0]) = 1) Then
    begin
        If(StrComp(PChar(Edit_Name.Text),@szvalnew[0])<>0) Then
        begin
            Modify_UDP := 0;
            Exit;
        end;
    end;

    If (ZN_GetDevConfigUDP('C1_OP', @szvalnew[0]) = 1) Then
    begin
        If (StrComp(PChar(Edit_Worktype.Text),@szvalnew[0])<>0) Then
        begin
            Modify_UDP := 0;
            Exit;
        end;
    end;
    
    If ZN_GetDevConfigUDP('C1_PORT', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_Workport.Text),@szvalnew[0])<>0) Then
        begin
            Modify_UDP := 0;
            Exit;
        end;
    end;
    
    If ZN_GetDevConfigUDP('C1_BAUD', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_Baud.Text),@szvalnew[0])<>0) Then
        begin
            Modify_UDP := 0;
            Exit;
        end;
    end;

    If ZN_GetDevConfigUDP('C1_DATAB', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_DataB.Text),@szvalnew[0])<>0) Then
        begin
            Modify_UDP := 0;
            Exit;
        end;
    end;

    If ZN_GetDevConfigUDP('C1_STOPB', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_StopB.Text),@szvalnew[0])<>0) Then
        begin
            Modify_UDP := 0;
            Exit;
        end;
    end;
    
    If ZN_GetDevConfigUDP('C1_PARITY', @szvalnew[0]) = 1 Then
    begin
        If (StrComp(PChar(Edit_Parity.Text),@szvalnew[0])<>0) Then
        begin
            Modify_UDP := 0;
            Exit;
        end;
    end;

    Modify_UDP := 1;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
selind:integer;
szip,szmac,str1: AnsiString;
devtype: BYTE;
res: integer;
begin
    selind := TryGetSelDev();
    If(selind = -1) Then
        Exit;
    szip:=ListView_Dev.Items.Item[selind].Caption;
    str1:=ListView_Dev.Items.Item[selind].SubItems[0];
    devtype:=BYTE(ListView_Dev.Items.Item[selind].Data);
    szmac:=ListView_Dev.Items.Item[selind].SubItems[1];
    str1:=ListView_Dev.Items.Item[selind].SubItems[2];

    //res := ZN_GetDevInfoUDPbyMACAndIP(PChar(szmac), PChar(szip),devtype);
    res := ZN_SendCmd(  devtype, PChar(szip) ,8801,'RESETDEV', PChar(szmac),  1);
end;

end.
