// testznetadvDlg.h : header file
//

#if !defined(AFX_TESTZNETADVDLG_H__18BE2F8A_082A_495B_AAC3_46826B2DAF03__INCLUDED_)
#define AFX_TESTZNETADVDLG_H__18BE2F8A_082A_495B_AAC3_46826B2DAF03__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CTestznetadvDlg dialog
#include "winsock2.h"
#include "iprtrmib.h"
#include "iphlpapi.h"
#include "GenGlobal.h"
#include <map>
using namespace std;

#define STRTOCHAR(x)	((LPTSTR)(LPCTSTR)(x))

class CTestznetadvDlg : public CDialog
{
// Construction
public:
	int Modify_UDP(char* szmac, BYTE devtype,char* szip);
	int Modify_TCP(BYTE devtype,char* szip,int port);
	int GetInfo_UDP(char* szmac, BYTE devtype,char *szip);
	int GetInfo_TCP(BYTE devtype,char* szip,int port);
	void GetDevices();
	void AddDevice(char* szip,char* szver,char* szmac,BYTE type,int port);
	int TryGetSelDev();
	CString GetDevType(BYTE devtype);
	void ClearDevices();
	CTestznetadvDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CTestznetadvDlg)
	enum { IDD = IDD_TESTZNETADV_DIALOG };
	CListCtrl	m_ctlList;
	int		m_bRadioUDP;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestznetadvDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CString m_strDesIP;
	map<CString,UINT> m_mapDevice;
	SOCKADDR_IN m_SockAddrArr[32];
	SOCKADDR_IN m_SockAddr;
	CString m_strLocalIP;
	CString m_strLocalIPArr[32];
	int		m_iIPCount;
	// Generated message map functions
	//{{AFX_MSG(CTestznetadvDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnButtonSearch();
	afx_msg void OnButtonGetinfo();
	afx_msg void OnButtonModify();
	afx_msg void OnButton1();
	afx_msg void OnRadioTcp();
	afx_msg void OnRadio2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTZNETADVDLG_H__18BE2F8A_082A_495B_AAC3_46826B2DAF03__INCLUDED_)
