﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        [DllImport("kernel32.dll")]
        static extern void Sleep(UInt32 ms);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_SearchAll();
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_Search([MarshalAs(UnmanagedType.LPStr)] String szip);
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetSearchDev( ref byte szip,
            ref byte szver,ref byte szmac,
            ref byte pdevtype, ref byte pipmode, ref int ptcpport);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetDevInfoUDPbyIP(
            [MarshalAs(UnmanagedType.LPStr)] string szip,
          byte devtype);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetDevInfoUDPbyMACAndIP(
            [MarshalAs(UnmanagedType.LPStr)] string szmac,
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            byte devtype);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetDevConfigUDP([MarshalAs(UnmanagedType.LPStr)] string szname,
            ref byte szval);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ResetModifyConfigUDP();

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_SetModifyConfigUDP(
            [MarshalAs(UnmanagedType.LPStr)] string szname,
            [MarshalAs(UnmanagedType.LPStr)] string szval);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ModifyDevUDPbyIP(
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            [MarshalAs(UnmanagedType.LPStr)] string szpwd,
          byte devtype);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ModifyDevUDPbyMACAndIP(
            [MarshalAs(UnmanagedType.LPStr)] string szmac,
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            [MarshalAs(UnmanagedType.LPStr)] string szpwd,
            byte devtype);

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_LoginTCP(byte devtype,
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            int port,
            [MarshalAs(UnmanagedType.LPStr)] string szpwd);
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetDevConfigTCP(
            [MarshalAs(UnmanagedType.LPStr)] string szname, ref byte szval);
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ModifyDevConfigTCP(
            [MarshalAs(UnmanagedType.LPStr)] string szname,
            [MarshalAs(UnmanagedType.LPStr)] string szval);
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ResetDevTCP();
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_ExitTCP();

        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_SendCmd(byte devtype,
            [MarshalAs(UnmanagedType.LPStr)] string szip,
            int port,
            [MarshalAs(UnmanagedType.LPStr)] string szname,
            [MarshalAs(UnmanagedType.LPStr)] string szval,
            byte budp);
                       
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_TCPInit([MarshalAs(UnmanagedType.LPStr)] string szip,
            int port);
        
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetAD(UInt32 hd,
            ref int padc0,
            ref int padc1);
        
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetIO(UInt32 hd,
            ref byte pdirection,
            ref byte pelevel);
        
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_SetIODir(UInt32 hd,
            byte dir);
        
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_GetIOLevel(UInt32 hd,
            byte level);
         
        [DllImport("ZNetAdv.dll")]
        static extern UInt32 ZN_TCPUninit(UInt32 hd);
        
        
        
        public Form1()
        {
            InitializeComponent();
        }

        public void ClearDevices()
        {
            listView_Dev.Items.Clear();
        }
        public string GetDevType(byte devtype)
        {
            Byte []devarr=new Byte[20];
            string []namearr=new string[20];
            devarr[0] = 1;
            devarr[1] = 2;
            devarr[2] = 3;
            devarr[3] = 4;
            devarr[4] = 5;
            devarr[5] = 6;
            devarr[6] = 7;
            devarr[7] = 8;
            devarr[8] = 11;
            devarr[9] = 12;
            devarr[10] = 13;
            devarr[11] = 48;

            namearr[0] = "ZNE-100";
            namearr[1] = "ZNE-100T";
            namearr[2] = "ZNE-10";
            namearr[3] = "ZNE-200T";
            namearr[4] = "NETCOM-10";
            namearr[5] = "ZNE-200";
            namearr[6] = "ZNE-10T";
            namearr[7] = "ZNE-100TI";
            namearr[8] = "CANET-E";
            namearr[9] = "CANET-100";
            namearr[10] = "CANET-200";
            namearr[11] = "NETCOM-400";

	        int sz=12,i=0;
	        string str1;
	        for(i=0;i<sz;i++)
	        {
		        if(devarr[i]==devtype)
		        {
                    str1=System.Convert.ToString(devtype)+"("+
                        namearr[i]+")";
			        return str1;
		        }
	        }
            str1=System.Convert.ToString(devtype);
	        return str1;
        }
        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            ClearDevices();
            ZN_SearchAll();
            int times=0;
            byte[] szip = new byte[20];
            byte[] szver = new byte[20];
            byte[] szmac = new byte[30];
            byte devtype=0,ipmode=0;
            int tcpport=0;
            for(;times<200;times++)
            {
                while (ZN_GetSearchDev(ref szip[0], ref szver[0], ref szmac[0], ref devtype, ref ipmode, ref tcpport) == 1)
                {
                    ListViewItem item = listView_Dev.Items.Add(
                        System.Text.Encoding.ASCII.GetString(szip));
                    item.SubItems.Add(GetDevType(devtype));
                    item.SubItems.Add(
                        System.Text.Encoding.ASCII.GetString(szmac));
                    if (devtype >= 32)
                        item.SubItems.Add(System.Convert.ToString(tcpport));
                    else
                        item.SubItems.Add("");
                }
                Sleep(10);
            }

        }

        public int TryGetSelDev()
        {
            if (listView_Dev.SelectedItems.Count > 0)
            {
                return listView_Dev.SelectedItems[0].Index;
            }
            return -1;
        }
        public int GetInfo_TCP(byte devtype, string szip, int port)
        {
            Form2 dlg=new Form2();
            dlg.ShowDialog();
            if(dlg.isOK()!=1)
	            return 0;
            string szpwd="";
            szpwd=dlg.GetPwd();
            if(ZN_LoginTCP(devtype,szip,port,szpwd)!=1)
	            return 0;
            uint res=1;
            byte []szval=new byte[100];

            res = ZN_GetDevConfigTCP("NAME", ref szval[0]);
            if(res != 1)
                goto ext;
            textBox_Name.Text = System.Text.Encoding.ASCII.GetString(szval);
            
            res = ZN_GetDevConfigTCP("C1_OP", ref szval[0]);
            if(res!=1)
                goto ext;
            textBox_Worktype.Text = System.Text.Encoding.ASCII.GetString(szval);
            
            res = ZN_GetDevConfigTCP("C1_PORT", ref szval[0]);
            if(res!=1)
                goto ext;
            
            textBox_Workport.Text = System.Text.Encoding.ASCII.GetString(szval);
            
            res = ZN_GetDevConfigTCP("C1_BAUD", ref szval[0]);
            if(res!=1)
                goto ext;
            
            textBox_Baud.Text =  System.Text.Encoding.ASCII.GetString(szval);
            
            res = ZN_GetDevConfigTCP("C1_DATAB", ref szval[0]);
            if(res!=1)
                goto ext;
            
            textBox_DataB.Text =  System.Text.Encoding.ASCII.GetString(szval);
            
            res = ZN_GetDevConfigTCP("C1_STOPB", ref szval[0]);
            if(res!=1)
                goto ext;
            
            textBox_StopB.Text =  System.Text.Encoding.ASCII.GetString(szval);

            res = ZN_GetDevConfigTCP("C1_PARITY", ref szval[0]);
            if(res!=1)
                goto ext;
            
            textBox_Parity.Text =  System.Text.Encoding.ASCII.GetString(szval);
            
        ext:
            ZN_ExitTCP();
            return (int)res;
        }

        public int GetInfo_UDP(string szmac, byte devtype, string szip)
        {
            uint res = ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype);
            byte[] szval = new byte[100];
            if(res!=1)
                return 0;
            
            res = ZN_GetDevConfigUDP("NAME", ref szval[0]);
            if(res==1)
                textBox_Name.Text =System.Text.Encoding.ASCII.GetString(szval);
            
            
            res = ZN_GetDevConfigUDP("C1_OP", ref szval[0]);
            if(res==1)
            textBox_Worktype.Text = System.Text.Encoding.ASCII.GetString(szval);
            
            
            res = ZN_GetDevConfigUDP("C1_PORT", ref szval[0]);
            if(res==1)
                textBox_Workport.Text = System.Text.Encoding.ASCII.GetString(szval);
            
            
            res = ZN_GetDevConfigUDP("C1_BAUD", ref szval[0]);
            if(res==1)
                textBox_Baud.Text = System.Text.Encoding.ASCII.GetString(szval);
            
            
            res = ZN_GetDevConfigUDP("C1_DATAB", ref szval[0]);
            if(res==1)
                textBox_DataB.Text = System.Text.Encoding.ASCII.GetString(szval);
            
            
            res = ZN_GetDevConfigUDP("C1_STOPB", ref szval[0]);
            if(res==1)
                textBox_StopB.Text = System.Text.Encoding.ASCII.GetString(szval);
            
            
            res = ZN_GetDevConfigUDP("C1_PARITY", ref szval[0]);
            if(res==1)
                textBox_Parity.Text = System.Text.Encoding.ASCII.GetString(szval);
            
            
            return (int)res;
        }
        private void button2_Click(object sender, EventArgs e)
        {
	        int selind=TryGetSelDev();
	        if(selind==-1)
	        {
		        return;
	        }
            string szip = "",str1="", szmac="";
	        byte devtype=0;
	        int tcpport=0;
            szip=listView_Dev.Items[selind].Text;
            szmac = listView_Dev.Items[selind].SubItems[2].Text;

            str1 = listView_Dev.Items[selind].SubItems[1].Text;
            if(str1.IndexOf('(')!=-1)
                str1 = str1.Substring(0,str1.IndexOf('('));
            devtype = System.Convert.ToByte(str1);
            str1 = listView_Dev.Items[selind].SubItems[3].Text;
	        if(str1!="")
                tcpport = System.Convert.ToInt32(str1);
	        int res=0;
	        if(radioTCP.Checked == true)
	        {
		        res=GetInfo_TCP(devtype,szip,tcpport);
	        }
	        else
	        {
		        res=GetInfo_UDP(szmac, devtype,szip);
	        }
	        if(res!=1)
                MessageBox.Show("获取信息失败", "错误",
                        MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	        else
                MessageBox.Show("获取信息成功", "信息",
                        MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        public int Modify_TCP(byte devtype,string szip,int port)
        {
            Form2 dlg=new Form2();
            dlg.ShowDialog();
            if(dlg.isOK()!=1)
	            return 0;
            string szpwd="";
            szpwd=dlg.GetPwd();
            if(ZN_LoginTCP(devtype, szip, port, szpwd)!=1)
                return 0;
            uint res = 1;

            res = ZN_ModifyDevConfigTCP("NAME", textBox_Name.Text);
            if(res!=1)
                goto ext;
            
            res = ZN_ModifyDevConfigTCP("C1_OP", textBox_Worktype.Text);
            if(res!=1)
                goto ext;
            
            res = ZN_ModifyDevConfigTCP("C1_PORT", textBox_Workport.Text);
            if(res!=1)
                goto ext;
            
            res = ZN_ModifyDevConfigTCP("C1_BAUD", textBox_Baud.Text);
            if(res!=1)
                goto ext;
            
            res = ZN_ModifyDevConfigTCP("C1_DATAB", textBox_DataB.Text);
            if(res!=1)
                goto ext;
            
            res = ZN_ModifyDevConfigTCP("C1_STOPB", textBox_StopB.Text);
            if(res!=1)
                goto ext;
            
            res = ZN_ModifyDevConfigTCP("C1_PARITY", textBox_Parity.Text);
            if(res!=1)
                goto ext;

        ext:
            ZN_ResetDevTCP();
            ZN_ExitTCP();
            return (int)res;
        }
        public int Modify_UDP(string szmac, byte devtype, string szip)
        {
            Form2 dlg=new Form2();
            dlg.ShowDialog();
            if(dlg.isOK()!=1)
	            return 0;
            string szpwd="";
            szpwd=dlg.GetPwd();

            ZN_ResetModifyConfigUDP();
            uint res = 1;
            res = ZN_SetModifyConfigUDP("NAME", textBox_Name.Text);
            res = ZN_SetModifyConfigUDP("C1_OP", textBox_Worktype.Text);
            res = ZN_SetModifyConfigUDP("C1_PORT", textBox_Workport.Text);
            res = ZN_SetModifyConfigUDP("C1_BAUD", textBox_Baud.Text);
            res = ZN_SetModifyConfigUDP("C1_DATAB", textBox_DataB.Text);
            res = ZN_SetModifyConfigUDP("C1_STOPB", textBox_StopB.Text);
            res = ZN_SetModifyConfigUDP("C1_PARITY", textBox_Parity.Text);

            res = ZN_ModifyDevUDPbyMACAndIP(szmac, szip, szpwd, devtype);
            if(res!=1)
                return 0;
            Sleep(500);
            
            res = ZN_GetDevInfoUDPbyMACAndIP(szmac, szip, devtype);
            if(res!=1)
                return 0;
            
            byte[] szvalnew=new byte[100];

            if (ZN_GetDevConfigUDP("NAME", ref szvalnew[0]) == 1)
            {
                if (System.String.Compare(textBox_Name.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                    return 0;
            }

            szvalnew = new byte[100];
             if(ZN_GetDevConfigUDP("C1_OP",ref szvalnew[0]) == 1)
                 if (System.String.Compare(textBox_Worktype.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                    return 0;

            szvalnew = new byte[100];
            if (ZN_GetDevConfigUDP("C1_PORT", ref szvalnew[0]) == 1)
                 if (System.String.Compare(textBox_Workport.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                    return 0;

            szvalnew = new byte[100];            
             if(ZN_GetDevConfigUDP("C1_BAUD",ref szvalnew[0]) == 1)
                 if (System.String.Compare(textBox_Baud.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                    return 0;

            szvalnew = new byte[100];
            if (ZN_GetDevConfigUDP("C1_DATAB", ref szvalnew[0]) == 1)
                 if (System.String.Compare(textBox_DataB.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                    return 0;

            szvalnew = new byte[100];
            if (ZN_GetDevConfigUDP("C1_STOPB", ref szvalnew[0]) == 1)
                 if (System.String.Compare(textBox_StopB.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                    return 0;

            szvalnew = new byte[100];
            if (ZN_GetDevConfigUDP("C1_PARITY", ref szvalnew[0]) == 1)
                 if (System.String.Compare(textBox_Parity.Text, System.Text.Encoding.ASCII.GetString(szvalnew), StringComparison.CurrentCulture) != 0)
                    return 0;
                
            return 1;
        }
        private void button3_Click(object sender, EventArgs e)
        {
	        int selind=TryGetSelDev();
	        if(selind==-1)
	        {
		        return;
	        }
            string szip = "", str1 = "", szmac="";
            byte devtype = 0;
            int tcpport = 0;
            szip = listView_Dev.Items[selind].Text;
            szmac = listView_Dev.Items[selind].SubItems[2].Text;

            str1 = listView_Dev.Items[selind].SubItems[1].Text;
            if (str1.IndexOf('(') != -1)
                str1 = str1.Substring(0, str1.IndexOf('('));
            devtype = System.Convert.ToByte(str1);
            str1 = listView_Dev.Items[selind].SubItems[3].Text;
            if (str1 != "")
                tcpport = System.Convert.ToInt32(str1);
            int res=0;
	        if(radioTCP.Checked == true)
	        {
		        res=Modify_TCP(devtype,szip,tcpport);
	        }
	        else
	        {
		        res=Modify_UDP(szmac, devtype,szip);
	        }
	        if(res!=1)
                MessageBox.Show("更改信息失败", "错误",
                        MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	        else
                MessageBox.Show("更改信息成功", "信息",
                        MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

    }
}