//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "znetadv.h"
#include "Unit2.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    int times;
    char szip[20];
    char szver[20];
    char szmac[30];
    BYTE devtype;
    BYTE ipmode;
    int tcpport;
    TListItem* item;

    ClearDevices();
    ZN_SearchAll();
    times=200;
    while(times>0)
    {
        while(ZN_GetSearchDev(szip,szver,szmac,&devtype,&ipmode,&tcpport)==1)
        {
          if(m_mapDevice[szmac] == 0)
                m_mapDevice[szmac] = 1;
          else
                continue;
          item=ListView_Dev->Items->Add();
          item->Data=Pointer(devtype);
          item->Caption=szip;
          item->SubItems->Add(GetDevType(devtype));
          item->SubItems->Add(szmac);
          if(devtype>=32)
              item->SubItems->Add(IntToStr(tcpport));
          else
              item->SubItems->Add("");
        }
        Sleep(10);
        times=times-1;
        ZN_SearchAll();	
    }
}
//---------------------------------------------------------------------------


void TForm1::ClearDevices()
{
    //TODO: Add your source code here
    ListView_Dev->Items->Clear();
}

AnsiString TForm1::GetDevType(BYTE devtype)
{
    AnsiString strtype;
    BYTE devarr[20];
    AnsiString namearr[20];
    int i;
    devarr[0] = 1;
    devarr[1] = 2;
    devarr[2] = 3;
    devarr[3] = 4;
    devarr[4] = 5;
    devarr[5] = 6;
    devarr[6] = 7;
    devarr[7] = 8;
    devarr[8] = 11;
    devarr[9] = 12;
    devarr[10] = 13;
    devarr[11] = 48;

    namearr[0] = "ZNE-100";
    namearr[1] = "ZNE-100T";
    namearr[2] = "ZNE-10";
    namearr[3] = "ZNE-200T";
    namearr[4] = "NETCOM-10";
    namearr[5] = "ZNE-200";
    namearr[6] = "ZNE-10T";
    namearr[7] = "ZNE-100TI";
    namearr[8] = "CANET-E";
    namearr[9] = "CANET-100";
    namearr[10] = "CANET-200";
    namearr[11] = "NETCOM-400";


    strtype = IntToStr(devtype);
    for(i= 0;i<12;i++)
    {
        if(devarr[i]==devtype)
            strtype = strtype + "(" + namearr[i] + ")";
    }
    return strtype;
}
void __fastcall TForm1::Button2Click(TObject *Sender)
{
    int selind;
    AnsiString szip,szmac,str1;
    BYTE devtype;
    int tcpport,res;

    selind = TryGetSelDev();
    if(selind == -1)
        return;
    szip=ListView_Dev->Items->Item[selind]->Caption;
    str1=((ListView_Dev->Items->Item[selind]->SubItems)->Strings[0]);
    devtype=BYTE(ListView_Dev->Items->Item[selind]->Data);
    szmac=ListView_Dev->Items->Item[selind]->SubItems->Strings[1];
    str1=ListView_Dev->Items->Item[selind]->SubItems->Strings[2];
    if(str1!="")
        tcpport = StrToInt(str1);

    if(RadioTCP->Checked == 1)
        res = GetInfo_TCP(devtype, szip, tcpport);
    else
        res = GetInfo_UDP(szmac, devtype, szip);
    if (res != 1)
        ShowMessage ("ȡϢʧ");
    else
        ShowMessage ("ȡϢɹ");
}
//---------------------------------------------------------------------------


int TForm1::TryGetSelDev()
{
    if(ListView_Dev->SelCount==0)
    {
        ShowMessage ("ѡһ豸");
        return -1;
    }
    return ListView_Dev->Selected->Index;
}

int TForm1::GetInfo_TCP(BYTE devtype, AnsiString szip, int tcpport)
{
    AnsiString szpwd;
    int res;
    int resGetInfo;
    char szval[100];

    Form2->ShowModal();
    if(Form2->isOK() == 0)
    {
        return 0;
    }
    szpwd = Form2->Edit1->Text;
    if(ZN_LoginTCP(devtype, szip.c_str(), tcpport, szpwd.c_str()) != 1)
    {
        return 0;
    }
    res = 1;
    res = ZN_GetDevConfigTCP("NAME", szval);
    if (res != 1)
        goto ext;
    Edit_Name->Text = szval;

    res = ZN_GetDevConfigTCP("C1_OP", szval);
    if (res != 1)
        goto ext;
    Edit_Worktype->Text = szval;

    res = ZN_GetDevConfigTCP("C1_PORT", szval);
    if (res != 1)
        goto ext;
    Edit_Workport->Text =szval;

    res = ZN_GetDevConfigTCP("C1_BAUD", szval);
    if (res != 1)
        goto ext;
    Edit_Baud->Text =szval;

    res = ZN_GetDevConfigTCP("C1_DATAB", szval);
    if (res != 1)
        goto ext;
    Edit_DataB->Text =szval;

    res = ZN_GetDevConfigTCP("C1_STOPB", szval);
    if (res != 1)
        goto ext;
    Edit_StopB->Text =szval;

    res= ZN_GetDevConfigTCP("C1_PARITY", szval);
    if (res != 1)
        goto ext;
    Edit_Parity->Text =szval;

ext:
    ZN_ExitTCP();
    return res;
}

int TForm1::GetInfo_UDP(AnsiString szmac, BYTE devtype, AnsiString szip)
{
    int resGetInfo;
    int res;
    char szval[20];

    resGetInfo = ZN_GetDevInfoUDPbyMACAndIP(szmac.c_str(), szip.c_str(),devtype);
    if (resGetInfo != 1)
        return 0;

    res = ZN_GetDevConfigUDP("NAME", szval);
    if (res == 1)
        Edit_Name->Text =szval;

    res = ZN_GetDevConfigUDP("C1_OP", szval);
    if (res == 1)
    Edit_Worktype->Text = szval;

    res = ZN_GetDevConfigUDP("C1_PORT", szval);
    if (res == 1)
        Edit_Workport->Text = szval;

    res = ZN_GetDevConfigUDP("C1_BAUD", szval);
    if (res == 1)
        Edit_Baud->Text = szval;

    res = ZN_GetDevConfigUDP("C1_DATAB", szval);
    if (res == 1)
        Edit_DataB->Text = szval;

    res = ZN_GetDevConfigUDP("C1_STOPB", szval);
    if (res == 1)
        Edit_StopB->Text = szval;

    res = ZN_GetDevConfigUDP("C1_PARITY", szval);
    if (res == 1)
        Edit_Parity->Text = szval;

    return resGetInfo;
}
void __fastcall TForm1::Button3Click(TObject *Sender)
{
    int selind;
    AnsiString szip,str1,szmac;
    BYTE devtype;
    int tcpport;
    int res;

    selind = TryGetSelDev();
    if(selind == -1)
        return;
    szip=ListView_Dev->Items->Item[selind]->Caption;
    str1=ListView_Dev->Items->Item[selind]->SubItems->Strings[0];
    szmac=ListView_Dev->Items->Item[selind]->SubItems->Strings[1];
    devtype=BYTE(ListView_Dev->Items->Item[selind]->Data);
    str1=ListView_Dev->Items->Item[selind]->SubItems->Strings[2];
    if(str1!="")
        tcpport = StrToInt(str1);

    if(RadioTCP->Checked == 1)
        res = Modify_TCP(devtype, szip, tcpport);
    else
        res = Modify_UDP(szmac, devtype, szip);
    if (res != 1)
        ShowMessage ("Ϣʧ");
    else
        ShowMessage ("Ϣɹ");
    
}
//---------------------------------------------------------------------------


int TForm1::Modify_TCP(BYTE devtype, AnsiString szip, int tcpport)
{
    int res;
    AnsiString szpwd;

    Form2->ShowModal();
    if(Form2->isOK() == 0)
        return 0;
    szpwd = Form2->Edit1->Text;

    if(ZN_LoginTCP(devtype, szip.c_str(), tcpport, szpwd.c_str()) != 1)
        return 0;
        
    res = 1;

    res = ZN_ModifyDevConfigTCP("NAME",Edit_Name->Text.c_str());
    if (res != 1)
        goto ext;

    res = ZN_ModifyDevConfigTCP("C1_OP", Edit_Worktype->Text.c_str());
    if (res != 1)
        goto ext;

    res = ZN_ModifyDevConfigTCP("C1_PORT", Edit_Workport->Text.c_str());
    if (res != 1)
        goto ext;

    res = ZN_ModifyDevConfigTCP("C1_BAUD", Edit_Baud->Text.c_str());
    if (res != 1)
        goto ext;

    res = ZN_ModifyDevConfigTCP("C1_DATAB", Edit_DataB->Text.c_str());
    if (res != 1)
        goto ext;

    res = ZN_ModifyDevConfigTCP("C1_STOPB", Edit_StopB->Text.c_str());
    if (res != 1)
        goto ext;

    res = ZN_ModifyDevConfigTCP("C1_PARITY", Edit_Parity->Text.c_str());
    if (res != 1)
        goto ext;

ext:
    ZN_ResetDevTCP();
    ZN_ExitTCP();
    return res;
}

int TForm1::Modify_UDP(AnsiString szmac, BYTE devtype, AnsiString szip)
{
    int res;
    AnsiString szpwd;
    char szvalnew[100];

    Form2->ShowModal();
    if(Form2->isOK() == 0)
        return 0;
    szpwd = Form2->Edit1->Text;

    ZN_ResetModifyConfigUDP();

    res = ZN_SetModifyConfigUDP("NAME", Edit_Name->Text.c_str());
    res = ZN_SetModifyConfigUDP("C1_OP", Edit_Worktype->Text.c_str());
    res = ZN_SetModifyConfigUDP("C1_PORT", Edit_Workport->Text.c_str());
    res = ZN_SetModifyConfigUDP("C1_BAUD", Edit_Baud->Text.c_str());
    res = ZN_SetModifyConfigUDP("C1_DATAB", Edit_DataB->Text.c_str());
    res = ZN_SetModifyConfigUDP("C1_STOPB", Edit_StopB->Text.c_str());
    res = ZN_SetModifyConfigUDP("C1_PARITY", Edit_Parity->Text.c_str());

    res = ZN_ModifyDevUDPbyMACAndIP(szmac.c_str(), szip.c_str(), szpwd.c_str(), devtype);
    if (res != 1)
        return 0;
    Sleep (500);

    //res = ZN_GetDevInfoUDPbyIP(szip.c_str(), devtype);
    res = ZN_GetDevInfoUDPbyMACAndIP(szmac.c_str(), szip.c_str(),devtype);
    if (res != 1)
        return 0;
    
    if (ZN_GetDevConfigUDP("NAME", szvalnew) == 1)
    {
        if(StrComp(Edit_Name->Text.c_str(),szvalnew)!=0)
            return 0;
    }

    if (ZN_GetDevConfigUDP("C1_OP", szvalnew) == 1)
    {
        if(StrComp(Edit_Worktype->Text.c_str(),szvalnew)!=0)
            return 0;
    }
    
    if (ZN_GetDevConfigUDP("C1_PORT", szvalnew) == 1)
    {
        if(StrComp(Edit_Workport->Text.c_str(),szvalnew)!=0)
            return 0;
    }

    if (ZN_GetDevConfigUDP("C1_BAUD", szvalnew) == 1 )
    {
        if(StrComp(Edit_Baud->Text.c_str(),szvalnew)!=0)
            return 0;
    }

    if (ZN_GetDevConfigUDP("C1_DATAB", szvalnew) == 1 )
    {
        if(StrComp(Edit_DataB->Text.c_str(),szvalnew)!=0)
            return 0;
    }

    if (ZN_GetDevConfigUDP("C1_STOPB", szvalnew) == 1 )
    {
        if(StrComp(Edit_StopB->Text.c_str(),szvalnew)!=0)
            return 0;
    }
    
    if (ZN_GetDevConfigUDP("C1_PARITY", szvalnew) == 1)
    {
        if(StrComp(Edit_Parity->Text.c_str(),szvalnew)!=0)
            return 0;
    }

    return 1;
}
