// testznetadvDlg.cpp : implementation file
//

#include "stdafx.h"
#include "testznetadv.h"
#include "testznetadvDlg.h"
#include "znetadv.h"
#include "DlgPwd1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestznetadvDlg dialog
static CString g_strname[]={"NAME","C1_OP","C1_PORT","C1_BAUD","C1_DATAB",
	"C1_STOPB","C1_PARITY"};
static UINT g_idarr[]={IDC_EDIT_NAME,IDC_EDIT_WORKTYPE,IDC_EDIT_PORT,
	IDC_EDIT_BAUD,IDC_EDIT_DATAB,IDC_EDIT_STOPB,IDC_EDIT_PARITY};

CTestznetadvDlg::CTestznetadvDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestznetadvDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestznetadvDlg)
	m_bRadioUDP = 1;
	m_strDesIP = "";
	m_iIPCount = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestznetadvDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestznetadvDlg)
	DDX_Control(pDX, IDC_LIST_DEV, m_ctlList);
	DDX_Radio(pDX, IDC_RADIO_TCP, m_bRadioUDP);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestznetadvDlg, CDialog)
	//{{AFX_MSG_MAP(CTestznetadvDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SEARCH, OnButtonSearch)
	ON_BN_CLICKED(IDC_BUTTON_GETINFO, OnButtonGetinfo)
	ON_BN_CLICKED(IDC_BUTTON_MODIFY, OnButtonModify)
	ON_BN_CLICKED(IDC_RADIO_TCP, OnRadioTcp)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestznetadvDlg message handlers

BOOL CTestznetadvDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_iIPCount = 0;
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ctlList.InsertColumn(0,"IP",LVCFMT_LEFT,120,0);
	m_ctlList.InsertColumn(1,"ͺ",LVCFMT_LEFT,80,1);
	m_ctlList.InsertColumn(2,"MAC",LVCFMT_LEFT,120,2);
	m_ctlList.InsertColumn(3,"TCP˿",LVCFMT_LEFT,80,3);
	m_ctlList.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	PMIB_IPNETTABLE pIpTable = NULL;
	DWORD dwSize=0;
	if (::GetIpNetTable(pIpTable, &dwSize, 1) == ERROR_INSUFFICIENT_BUFFER)
	{
		pIpTable = (PMIB_IPNETTABLE)::GlobalAlloc(GPTR, dwSize);
		if (::GetIpNetTable(pIpTable, &dwSize, 1) == NO_ERROR)
		{
			for (int i=0; i<pIpTable->dwNumEntries; i++)
			{
				::DeleteIpNetEntry( &(pIpTable->table[i]) );
			}

			::GlobalFree(pIpTable);		
		}
	}


	// TODO: Add extra initialization here
	TCHAR szHost[256];
	::gethostname(szHost, 256);
	hostent* pHost = ::gethostbyname(szHost);
	//	in_addr addr;
	for (int i=0; 1; i++)
	{
		char* p = pHost->h_addr_list[i];
		if (p == NULL)
			break;

		memcpy((char FAR *)&(m_SockAddrArr[i].sin_addr), p,pHost->h_length); 
		m_strLocalIP.Format("%d.%d.%d.%d",	m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b1,
			m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b2,
			m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b3,
			m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b4);

		m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b4=1;
		m_iIPCount++;
	}



	char szname[256];
	gethostname(szname,256);
	hostent* phost=gethostbyname(szname);
	memcpy((char FAR *)&(m_SockAddr.sin_addr), phost->h_addr,phost->h_length); 
	m_strLocalIP.Format("%d.%d.%d.%d",	m_SockAddr.sin_addr.S_un.S_un_b.s_b1,
		m_SockAddr.sin_addr.S_un.S_un_b.s_b2,
		m_SockAddr.sin_addr.S_un.S_un_b.s_b3,
		m_SockAddr.sin_addr.S_un.S_un_b.s_b4);

	m_SockAddr.sin_addr.S_un.S_un_b.s_b4=1;

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestznetadvDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestznetadvDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestznetadvDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestznetadvDlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

void CTestznetadvDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CTestznetadvDlg::OnButtonSearch() 
{
	ClearDevices();
	m_mapDevice.clear();
	m_strDesIP = "";
	CString strDesIP;
	//ZN_SearchAll();
	int times=1000;
	int iCount=0;
	char szip[20],szver[20],szmac[30];
	BYTE devtype,ipmode;
	int tcpport;
	while(times-->0)
	{
		GetDevices();
		if(times%10==0)
		{
			ZN_SearchAll();			
		}
		else if ((iCount > 230 && iCount <505) || (iCount > 550) )
		{
			CString str;
			//	if (ISEND_SEARCH++ %3 == 0)
			//	{
			for(int i=0; i<m_iIPCount; i++)
			{
				str.Format(	"%d.%d.%d.%d",	
					m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b1,
					m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b2,
					m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b3,
					m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b4++);

				if(m_strLocalIP!=str)
					ZN_Search(STRTOCHAR(str));

				if (m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b4==255 )
					m_SockAddrArr[i].sin_addr.S_un.S_un_b.s_b4 = 1;
			}

			//	}					
		}

		iCount++;
		Sleep(10);
	}
	if(m_strDesIP.GetLength()==0)
		MessageBox("û豸");
}

void CTestznetadvDlg::GetDevices()
{
	char szip[30],szver[20],szmac[25];
	BYTE type,ipmode;
	int tcpport;

	while(ZN_GetSearchDev(szip,szver,szmac,&type,&ipmode,&tcpport))
	{
		if(m_mapDevice[szmac] == 0)
			m_mapDevice[szmac] = 1;
		else
			continue;
		m_strDesIP = szip;
		AddDevice(szip,szver,szmac,type,tcpport);
	}
}

void CTestznetadvDlg::AddDevice( char* szip,char* szver,char* szmac,BYTE type,int port )
{
	int ind=m_ctlList.InsertItem(m_ctlList.GetItemCount(),szip);
	m_ctlList.SetItemText(ind,1,GetDevType(type));
	m_ctlList.SetItemText(ind,2,szmac);
	if(type>=TYPE_ZNE300T)
	{
		CString str1;
		str1.Format("%d",port);
		m_ctlList.SetItemText(ind,3,str1);
	}
	m_ctlList.Invalidate();
	m_ctlList.UpdateWindow();
}

void CTestznetadvDlg::ClearDevices()
{
	m_ctlList.DeleteAllItems();
	m_ctlList.Invalidate();
	m_ctlList.UpdateWindow();
}

CString CTestznetadvDlg::GetDevType(BYTE devtype)
{
	static BYTE devarr[]={TYPE_ZNE100,TYPE_ZNE100T,TYPE_ZNE10,TYPE_ZNE200T,
		TYPE_ZNETCOM10S,TYPE_ZNE200,TYPE_ZNE10T,TYPE_ZNE100TI,TYPE_CANETE,
		TYPE_CANET100,TYPE_CANET200,TYPE_NETCOM400};
	static CString namearr[]={"ZNE-100","ZNE-100T","ZNE-10","ZNE-200T",
		"NETCOM-10","ZNE-200","ZNE-10T","ZNE-100TI","CANET-E",
		"CANET-100","CANET-200","NETCOM-400"};

	int sz=sizeof(devarr);
	CString str1;
	for(int i=0;i<sz;i++)
	{
		if(devarr[i]==devtype)
		{
			str1.Format("%d(%s)",devtype,namearr[i]);
			return str1;
		}
	}
	str1.Format("%d",devtype);
	return str1;
}

void CTestznetadvDlg::OnButtonGetinfo() 
{
	// TODO: Add your control notification handler code here
	int selind=TryGetSelDev();
	if(selind==-1)
	{
		return;
	}
	char szip[20],szmac[30];
	CString str1;
	BYTE devtype;
	int tcpport;
	m_ctlList.GetItemText(selind,0,szip,20);
	str1=m_ctlList.GetItemText(selind,1);
	devtype=atoi(str1);
	m_ctlList.GetItemText(selind,2,szmac,30);
	str1=m_ctlList.GetItemText(selind,3);
	if(str1!="")
		tcpport=atoi(str1);
	int res;

    //udp
	if(m_bRadioUDP == 1)
	{
		res=GetInfo_TCP(devtype,szip,tcpport);
	}
	else
	{
		res=GetInfo_UDP(szmac, devtype,szip);
	}
	if(res!=1)
		MessageBox("ȡϢʧ");
	else
		MessageBox("ȡϢɹ");

}

int CTestznetadvDlg::TryGetSelDev()
{
	POSITION pos=m_ctlList.GetFirstSelectedItemPosition();
	if(pos)
	{
		int ind=m_ctlList.GetNextSelectedItem(pos);
		return ind;
	}
	MessageBox("ѡһ豸");
	return -1;
}


int CTestznetadvDlg::GetInfo_TCP(BYTE devtype,char *szip, int port)
{
	CDlgPwd dlg;
	if(dlg.DoModal()!=IDOK)
		return 0;
	char szpwd[20];
	strcpy(szpwd,dlg.GetPwd());
	int ret=ZN_LoginTCP(devtype,szip,port,szpwd);
	if(ret!=1)
		return 0;
	int res=1;
	char szval[100];

	int sz=sizeof(g_strname)/sizeof(CString);
	for(int i=0;i<sz;i++)
	{
		res=ZN_GetDevConfigTCP((char*)(LPCTSTR)g_strname[i],szval);
		if(res!=1)
			goto ext;
		GetDlgItem(g_idarr[i])->SetWindowText(szval);
	}

    
ext:
	ZN_ExitTCP();
	return res;
}

int CTestznetadvDlg::GetInfo_UDP(char* szmac, BYTE devtype,char *szip)
{
	DWORD res=ZN_GetDevInfoUDPbyMACAndIP(szmac, szip,devtype);
	char szval[100];
	if(res!=1)
		return res;
	int sz=sizeof(g_strname)/sizeof(CString);
	for(int i=0;i<sz;i++)
	{
		if(ZN_GetDevConfigUDP((char*)(LPCTSTR)g_strname[i],szval)!=1)
			continue;
		GetDlgItem(g_idarr[i])->SetWindowText(szval);
	}

	return res;
}

void CTestznetadvDlg::OnButtonModify() 
{
	// TODO: Add your control notification handler code here
	int selind=TryGetSelDev();
	if(selind==-1)
	{
		return;
	}
	char szip[20],szmac[30];
	CString str1;
	BYTE devtype;
	int tcpport;
	m_ctlList.GetItemText(selind,0,szip,20);
	str1=m_ctlList.GetItemText(selind,1);
	devtype=atoi(str1);
	m_ctlList.GetItemText(selind,2,szmac,30);
	str1=m_ctlList.GetItemText(selind,3);
	if(str1!="")
		tcpport=atoi(str1);
	int res;

	if(m_bRadioUDP == 1)
	{
		res=Modify_TCP( devtype,szip,tcpport);
	}
	else
	{
		res=Modify_UDP(szmac,devtype,szip);
	}
	if(res!=1)
		MessageBox("Ϣʧ");
	else
		MessageBox("Ϣɹ");
	
}

int CTestznetadvDlg::Modify_TCP(BYTE devtype, char *szip, int port)
{
	CDlgPwd dlg;
	if(dlg.DoModal()!=IDOK)
		return 0;
	char szpwd[20];
	strcpy(szpwd,dlg.GetPwd());
	if(ZN_LoginTCP(devtype,szip,port,szpwd)!=1)
		return 0;
	int res=1;
	char szval[100];

	int sz=sizeof(g_strname)/sizeof(CString);
	for(int i=0;i<sz;i++)
	{
		GetDlgItem(g_idarr[i])->GetWindowText(szval,100);
		res=ZN_ModifyDevConfigTCP((char*)(LPCTSTR)g_strname[i],szval);
		if(res!=1)
			goto ext;
	}
    
ext:
	ZN_ResetDevTCP();
	ZN_ExitTCP();
	return res;	
}

int CTestznetadvDlg::Modify_UDP(char* szmac, BYTE devtype, char *szip)
{
	CDlgPwd dlg;
	if(dlg.DoModal()!=IDOK)
		return 0;
	char szpwd[20];
	strcpy(szpwd,dlg.GetPwd());

	char szval[100];
	ZN_ResetModifyConfigUDP();
	int sz=sizeof(g_strname)/sizeof(CString);
	for(int i=0;i<sz;i++)
	{
		GetDlgItem(g_idarr[i])->GetWindowText(szval,100);
		ZN_SetModifyConfigUDP((char*)(LPCTSTR)g_strname[i],szval);
	}
	int res=ZN_ModifyDevUDPbyMACAndIP(szmac, szip,szpwd,devtype);
	if(res!=1)
		return res;
	Sleep(500);
	res=ZN_GetDevInfoUDPbyMACAndIP(szmac, szip,devtype);
	if(res!=1)
		return res;
	char szvalnew[100];
	for(int i=0;i<sz;i++)
	{
		GetDlgItem(g_idarr[i])->GetWindowText(szval,100);
		if(ZN_GetDevConfigUDP((char*)(LPCTSTR)g_strname[i],szvalnew)!=1)
			continue;
		if(strcmp(szval,szvalnew)!=0)
			return 0;
	}
	return 1;
}

void CTestznetadvDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	
}

void CTestznetadvDlg::OnRadioTcp() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
}

void CTestznetadvDlg::OnRadio2() 
{
	// TODO: Add your control notification handler code here
    UpdateData();	
}



BOOL CTestznetadvDlg::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ڴϢ/Ĭֵ

	return CDialog::OnEraseBkgnd(pDC);
}
